def _number_operator():
    return {
        "oneOf": [
            {
                "type": "number",
                "description": "Равно"
            },
            {
                "type": "array",
                "items": {
                    "type": "number"
                },
                "description": "Содержится в списке"
            },
            {
                "type": "object",
                "additionalProperties": False,
                "minProperties": 1,
                "properties": {
                    "$eq": {
                        "type": "number",
                        "description": "Равно"
                    },
                    "$ne": {
                        "type": "number",
                        "description": "Не равно"
                    },
                    "$gt": {
                        "type": "number",
                        "description": "Больше"
                    },
                    "$gte": {
                        "type": "number",
                        "description": "Больше или равно"
                    },
                    "$lt": {
                        "type": "number",
                        "description": "Меньше"
                    },
                    "$lte": {
                        "type": "number",
                        "description": "Меньше"
                    },
                    "$in": {
                        "type": "array",
                        "items": {
                            "type": "number"
                        },
                        "description": "Содержится в списке"
                    }
                }
            }
        ]
    }


def _string_operator():
    return {
        "oneOf": [
            {
                "type": "string",
                "description": "Равно"
            },
            {
                "type": "array",
                "items": {
                    "type": "string"
                },
                "description": "Содержится в списке"
            },
            {
                "type": "object",
                "additionalProperties": False,
                "minProperties": 1,
                "properties": {
                    "$eq": {
                        "type": "string",
                        "description": "Равно"
                    },
                    "$ne": {
                        "type": "string",
                        "description": "Не равно"
                    },
                    "$like": {
                        "type": "string",
                        "description": "Содержит"
                    },
                    "$ilike": {
                        "type": "string",
                        "description": "Содержит регистронезависимо"
                    },
                    "$in": {
                        "type": "array",
                        "items": {
                            "type": "string"
                        },
                        "description": "Содержится в списке"
                    }
                }
            }
        ]
    }


def _datetime_operator():
    return {
        "oneOf": [
            {
                "type": "string",
                "format": "date-time",
                "description": "Равно"
            },
            {
                "type": "array",
                "items": {
                    "type": "string"
                },
                "format": "date-time",
                "description": "Содержится в списке"
            },
            {
                "type": "object",
                "additionalProperties": False,
                "minProperties": 1,
                "properties": {
                    "$eq": {
                        "type": "string",
                        "format": "date-time",
                        "description": "Равно"
                    },
                    "$ne": {
                        "type": "string",
                        "format": "date-time",
                        "description": "Не равно"
                    },
                    "$gt": {
                        "type": "string",
                        "format": "date-time",
                        "description": "Больше"
                    },
                    "$gte": {
                        "type": "string",
                        "format": "date-time",
                        "description": "Больше или равно"
                    },
                    "$lt": {
                        "type": "string",
                        "format": "date-time",
                        "description": "Меньше"
                    },
                    "$lte": {
                        "type": "string",
                        "format": "date-time",
                        "description": "Меньше"
                    },
                    "$in": {
                        "type": "array",
                        "items": {
                            "type": "string",
                            "format": "date-time"
                        },
                        "description": "Содержится в списке"
                    }
                }
            }
        ]
    }


def _uuid_operator():
    return {
        "oneOf": [
            {
                "type": "string",
                "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$",
                "description": "Равно"
            },
            {
                "type": "array",
                "items": {
                    "type": "string",
                    "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$"
                },
                "description": "Содержится в списке"
            },
            {
                "type": "object",
                "additionalProperties": False,
                "minProperties": 1,
                "properties": {
                    "$eq": {
                        "type": "string",
                        "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$",
                        "description": "Равно"
                    },
                    "$ne": {
                        "type": "string",
                        "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$",
                        "description": "Не равно"
                    },
                    "$like": {
                        "type": "string",
                        "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$",
                        "description": "Содержит"
                    },
                    "$ilike": {
                        "type": "string",
                        "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$",
                        "description": "Содержит регистронезависимо"
                    },
                    "$in": {
                        "type": "array",
                        "items": {
                            "pattern": "^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$",
                            "type": "string"
                        },
                        "description": "Содержится в списке"
                    }
                }
            }
        ]
    }


def _null_operator():
    return {
        "oneOf": [
            {
                "type": "null",
                "description": "Равно"
            },
            {
                "type": "object",
                "additionalProperties": False,
                "minProperties": 1,
                "properties": {
                    "$eq": {
                        "type": "null",
                        "description": "Равно"
                    },
                    "$ne": {
                        "type": "null",
                        "description": "Не равно"
                    }
                }
            }
        ]
    }


def _boolean_operator():
    return {
        "oneOf": [
            {
                "type": "boolean",
                "description": "Равно"
            },
            {
                "type": "object",
                "additionalProperties": False,
                "minProperties": 1,
                "properties": {
                    "$eq": {
                        "type": "boolean",
                        "description": "Равно"
                    },
                    "$ne": {
                        "type": "boolean",
                        "description": "Не равно"
                    }
                }
            }
        ]
    }


def definitions():
    return {
        "operators": {
            "number": _number_operator(),
            "integer": _null_operator(),
            "string": _string_operator(),
            "datetime": _datetime_operator(),
            "uuid": _uuid_operator(),
            "null": _null_operator(),
            "boolean": _boolean_operator()
        }
    }
